﻿using System;
using System.Linq;

namespace Recipe05
{
    class Program
    {
        static void Main(string[] args)
        {
            // --- Clean up the database: remove all orders with their details
            using (var context = new OrderDatabaseContext())
            {
                foreach (var detail in context.Details)
                {
                    context.Details.Remove(detail);
                }

                foreach (var order in context.Orders)
                {
                    context.Orders.Remove(order);
                }
                context.SaveChanges();
            }

            using (var context = new OrderDatabaseContext())
            {
                for (int i = 0; i < 5; i++)
                {
                    var order = new Order
                                    {
                                        Customer = "Customer " + i,
                                        OrderDate = DateTime.Now,
                                        Total = 10*i,
                                        Status = "NEW",
                                    };
                    context.Orders.Add(order);
                    for (int j = 0; j < 3; j++)
                    {
                        var detail = new OrderDetail
                                         {
                                             Amount = 10*j + i,
                                             Product = "Product" + j,
                                             UnitPrice = 10 + j,
                                             Order = order
                                         };
                        context.Details.Add(detail);
                    }
                }
                context.SaveChanges();
            }

            // --- Read orders and the corresponding details
            using (var context = new OrderDatabaseContext())
            {
                foreach (var order in context.Orders)
                {
                    Console.WriteLine("Order with ID #{0} contains {1} details", 
                        order.Id, order.Details.Count());
                }
            }
        }
    }
}
